//************************************************
// Romeo.c
//************************************************
// Tutorial XFT35-05: Hardware implementation of
// fuzzy controllers with xfsg
//************************************************

#include <math.h>  		     /* Math function definitions */
#include "Test_Romeo.h"

void Romeo (double sref, double gref) {
 
   double x, y, phi;         // phi = angle in radians
   double speed, oldspeed;
   double gamma, oldgamma;
   double t;
 
   oldspeed = status.speed;
   speed = oldspeed;

   oldgamma = status.gamma;
   gamma = oldgamma;

   x = status.x;
   y = status.y;
   phi = status.angle*PI/180.0;
 
   // Control cycle
   
   for(t=0.0; t<=LAPSE; t+=0.001) {
     x += speed * sin(phi)*0.001;
     y += speed * cos(phi)*0.001;
     phi += speed * gamma * 0.001;
     if (phi > PI) phi -= 2*PI;
     if (phi < -PI) phi += 2*PI;
     speed = sref + (oldspeed-sref)*exp(-t/V_TAU);
     gamma = gref + (oldgamma-gref)*exp(-t/P_TAU);
     if( gamma > 0.4) gamma = 0.4;
     if( gamma < -0.4) gamma = -0.4;
   }
   
   status.x = x;
   status.y = y;
   status.angle = phi*180.0/PI;
   status.speed = speed;
   status.gamma = gamma;
   
   return ;
}
